%MACRO DtTm2Six (SASdttm); %* by Jim Groeneveld, 10jun2013;
  %LOCAL Six Value Offset;

%* Convert years;
%* Only applies to SAS dates between 01jan2000 and 31dec2061;
  %LET Value = %SYSFUNC(YEAR(%SYSFUNC(DATEPART(&SASdttm))));
  %IF (&Value LT 2000 OR &Value GT 2061) %THEN %GOTO NotDone;
  %ELSE %IF (&Value LE 2009) %THEN %LET Offset = %SYSFUNC(RANK(0));
  %ELSE %IF (&Value LE 2035) %THEN %LET Offset = %EVAL(%SYSFUNC(RANK(A))-10);
  %ELSE %IF (&Value LE 2061) %THEN %LET Offset = %EVAL(%SYSFUNC(RANK(a))-36);
  %*put DEBUG YEAR = &Value, Offset = &Offset;
  %LET Six = %SYSFUNC(BYTE(%EVAL(&Value+&Offset)-2000));

%* Convert months;
  %LET Value = %SYSFUNC(MONTH(%SYSFUNC(DATEPART(&SASdttm))));
  %IF (&Value LE 9) %THEN %LET Offset = %SYSFUNC(RANK(0));
  %ELSE %LET Offset = %EVAL(%SYSFUNC(RANK(A))-10);
  %*put DEBUG MONTH = &Value, Offset = &Offset;
  %LET Six = &Six%SYSFUNC(BYTE(%EVAL(&Value+&Offset)));

%* Convert days;
  %LET Value = %SYSFUNC(DAY(%SYSFUNC(DATEPART(&SASdttm))));
  %IF (&Value LE 9) %THEN %LET Offset = %SYSFUNC(RANK(0));
  %ELSE %LET Offset = %EVAL(%SYSFUNC(RANK(A))-10);
  %*put DEBUG DAY = &Value, Offset = &Offset;
  %LET Six = &Six%SYSFUNC(BYTE(%EVAL(&Value+&Offset)));

%* Convert hours;
  %LET Value = %SYSFUNC(HOUR(&SASdttm));
  %IF (&Value LE 9) %THEN %LET Offset = %SYSFUNC(RANK(0));
  %ELSE %LET Offset = %EVAL(%SYSFUNC(RANK(A))-10);
  %*put DEBUG HOUR = &Value, Offset = &Offset;
  %LET Six = &Six%SYSFUNC(BYTE(%EVAL(&Value+&Offset)));

%* Convert minutes;
  %LET Value = %SYSFUNC(MINUTE(&SASdttm));
  %IF (&Value LE 9) %THEN %LET Offset = %SYSFUNC(RANK(0));
  %ELSE %IF (&Value LE 35) %THEN %LET Offset = %EVAL(%SYSFUNC(RANK(A))-10);
  %ELSE %LET Offset = %EVAL(%SYSFUNC(RANK(a))-36);
  %*put DEBUG MINUTE = &Value, Offset = &Offset;
  %LET Six = &Six%SYSFUNC(BYTE(%EVAL(&Value+&Offset)));

%* Convert seconds;
  %LET Value = %SYSFUNC(FLOOR(%SYSFUNC(SECOND(&SASdttm))));
  %IF (&Value LE 9) %THEN %LET Offset = %SYSFUNC(RANK(0));
  %ELSE %IF (&Value LE 35) %THEN %LET Offset = %EVAL(%SYSFUNC(RANK(A))-10);
  %ELSE %LET Offset = %EVAL(%SYSFUNC(RANK(a))-36);
  %*put DEBUG SECOND = &Value, Offset = &Offset, Seconds = &Value;
  %LET Six = &Six%SYSFUNC(BYTE(%EVAL(&Value+&Offset)));

%NotDone:
%* Process years outside supported range;
  %IF (NOT %LENGTH(%SUPERQ(Six))) %THEN %LET Six = ------;
%* Return Six;
  &Six;

%MEND DtTm2Six;

%* Examples;
%LET Now = %SYSFUNC(DATETIME());
%LET Now = %sysevalf('10jun2013:11.09.40'DT);
%PUT Now = formatted: %SYSFUNC(PUTN(&Now,DATETIME22.));
%LET Now = %DtTm2Six(&Now);
%PUT Now = converted: &Now;
